%%% Script to convert the image recorded by the CCD to the emission map in
%%% polar coordinates


% clear all;close all;clc;

imageCCD =         doPlots; % Plot of intensity as recorded by CCD: y/n
applyMASK =        'y'; % Set all data values outside mirror area to 0: y/n
plotMASK =         'n'; % Plot masked data: y/n
aberPHI =          'n'; % Remove from calc the area of severe aberration: y/n
solidANGLEnorm =   'y'; % Performs normalization by solid angle: y/n
plotMIRRORangles = 'n'; % Plots the distribution of PHI,THETA,OMEGA onto mirror CCD projection: y/n
intVStheta =       'n'; % Returns intensity as function of THETA (integration over PHI):y/n
PLOTpolar =        doPlots; % Plot of intensity in polar coordinates (radius=THETA, angle=PHI):y/n !!! HEAVY MEMORY CONSUMPTION !!!
doSUBTRACT=        'n'; % Subtract flat gold data?

%%% load the file(s)

%%% spectra with no filter
% data3 = load('D:\Documents and Settings\gia\My Documents\giorgio\Measurements\SEM\2011-08-02 ASR D1-D3 RTA\Au22nA20sNOfilterNEW1.dat');
% data4 = load('D:\Documents and Settings\gia\My Documents\giorgio\Measurements\SEM\2011-08-02 ASR D1-D3 RTA\D1_22nA20sNOfilterNEW1.dat');

% %%% spectra with filter @ 500nm
% data3 = load('D:\Documents and Settings\gia\My Documents\giorgio\Measurements\SEM\2011-08-02 ASR D1-D3 RTA\Au22nA20s500filterNEW1.dat');
% data4 = load('D:\Documents and Settings\gia\My Documents\giorgio\Measurements\SEM\2011-08-02 ASR D1-D3 RTA\D1_22nA20s500filterNEW1.dat');

% %%% spectra with filter @ 650nm
%data3=100*rand(257,1025);         baregold_30s_9.01nA_800filter_8circle   for planewave and tc1-7            baregold_30s_7.28nA_255deg for 12-01 tc8-10, 20and 30
%data3 = load('E:\Users\Guanhai\comsol\Hologram\hologram generation\holo_image\data for experiment\data_postprocessing\2014-12-21_process\baregold_near10um_30s_5.20nA.txt');

%import bare gold data
%data3 = importfile('2015-04-01-1823-filter- flat gold 10s 3200pA.txt');
%figure(10);imagesc(data3);
%data4 = load('E:\Users\Guanhai\comsol\Hologram\hologram generation\holo_image\data for experiment\data_postprocessing\2014-12-21_process\hologram_40um_30s_5.04nA_new.txt');

%import experiment sample data
%data4 = importfile('2015-04-01-1828-filter- holo 90deg depth 5 10s 3230pA.txt');
%figure(11);imagesc(data4);
%%% for MAC
% data3 = load('/Users/censor/Desktop/2011-08-02 ASR D1-D3 RTA\Au22nA20s650filterNEW1.dat');
% data4 = load('/Users/censor/Desktop/2011-08-02 ASR D1-D3 RTA\D1_22nA20s650filterNEW1.dat');

%% parameters of the parabolic image on CCD
%%% specifiy parameters for the parabolic image on the CCD (this part
%%% needs to be inserted manually until a fixed setup for CCD imaging is
%%% not set up.

%%% spectra with no filter
%%% 2011-08-02 ASR D1-D3 RTA\Au22nA20sNOfilterNEW1.dat & D1_22nA20sNOfilterNEW1.dat
%%% xMINimagePIXpos = 241; yMINimagePIXpos = 101; XimagePIX = 97;%
%%%
%%% spectra with filter @ 500nm
%%% 2011-08-02 ASR D1-D3 RTA\Au22nA20s500filterNEW1.dat & D1_22nA20s500filterNEW1.dat
%%% xMINimagePIXpos = 286; yMINimagePIXpos = 101; XimagePIX = 97;%
%%%
%%% spectra with filter @ 650nm
%%% 2011-08-02 ASR D1-D3 RTA\Au22nA20s650filterNEW1.dat & D1_22nA20s650filterNEW1.dat
%%% xMINimagePIXpos = 277; yMINimagePIXpos = 107; XimagePIX = 97;%

%%% position of the parabola semicircle minimum central point (below HOLE)
xMINimagePIXpos = 323; % number of pixels    %%%for tc7-30 (x,y)=(280,210) for tc1-7 (x,y)=(285,208)
yMINimagePIXpos = 156; % number of pixels
%%% half size of the mirror in the image recorded by the CCD
XimagePIX = 34; % number of pixels
%%% azimuthal angle for which the aberration of the mirror is most severe?
%%% phiABERdeg1 < PHI < phiABERdeg2
phiABERdeg1 = 30;
phiABERdeg2 = 90;


data3=data4;
%% retrieve the data from files (without x-y coordinates vectors)
[rr cc]=size(data3);
ddata3 = data3(2:rr,2:cc)-min(min(data3(2:rr,2:cc)));
%ddata3 = data3(2:rr,2:cc)-min(min(data3(2:rr,2:cc)));
ddata4 = data4(2:rr,2:cc)-min(min(data4(2:rr,2:cc)));
ddata43 = ddata4;%-ddata3;
%%% negative values of ddata43 explicitely set to 0
%%% !!! COMMENT IF NOT WANTED!!!
%%%
for mm = 1 : (rr-1)
    for nn = 1 : (cc-1)
        if ddata43(mm,nn) < 0
            ddata43(mm,nn) = 0;
        end
    end
end

%%% retrieve the x-y coordinates vectors
x_coord = data3(1,2:cc)';
x_size = max(size(x_coord));
y_coord = data3(2:rr,1);
y_size = max(size(y_coord));

%%% position of the parabola emicircle minimum central point in pixel coordinate (pixel centre)
xMINimagePIX = x_coord(xMINimagePIXpos);
yMINimagePIX = y_coord(yMINimagePIXpos);


%% parabolic mirror physical dimensions (mm)

X = 18.7; % dimension of mirror section on x direction (mm)
Y = 8.1; % dimension of mirror section on y direction (mm)
Z = 9.7; % dimension of mirror section on z direction (mm)

[rMIRR,k,d,Fx,Fy,Fz,beta,delta,FdistY,xHOLE,yHOLE,zHOLE] = parMIRRphysDIM(X,Y,Z);

%% mirror projection on CCD, without focusing lens (number of pixels)

physPIXsize = 26e-3; % physical size of the pixel(mm)

XphysPIX = round(X/physPIXsize);
YphysPIX = round(Y/physPIXsize);
rMIRRphysPIX = round(rMIRR/physPIXsize);
yHOLEphysPIX = round(yHOLE/physPIXsize);

%% mirror projection onto the actual acquired CCD image using a lens (number of pixels)

physTOimagePIX = XphysPIX/(2*XimagePIX); % demagnification factor induced by the lens
YimagePIX = round(YphysPIX/physTOimagePIX); % Y dimension in the recorded image
rMIRRimagePIX = round(rMIRRphysPIX/physTOimagePIX); % radius of the mirror in the recorde image
yHOLEimagePIX = round(yHOLEphysPIX/physTOimagePIX); % vertical distance of hole from vertex in the recorde image


xVERTEXimagePIX = xMINimagePIX; % x position of the parabola vertex in the image (virtual)
yVERTEXimagePIX = yMINimagePIX + (rMIRRimagePIX - YimagePIX); % y position of the parabola vertex in the image (virtual)


%% defining the area of interest, containing the parabolic image (pixels)
%%% area of interest in the CCD (ccordinates)
x_coordMODimagePIX = x_coord(xMINimagePIXpos-XimagePIX-10:xMINimagePIXpos+XimagePIX+10); x_sizeMODimagePIX = max(size(x_coordMODimagePIX));
y_coordMODimagePIX = y_coord(yMINimagePIXpos-YimagePIX-10:yMINimagePIXpos+10); y_sizeMODimagePIX = max(size(y_coordMODimagePIX));
%%% area of interest in the CCD (data)
dataMOD3imagePIX = ddata3(yMINimagePIXpos-YimagePIX-10:yMINimagePIXpos+10,xMINimagePIXpos-XimagePIX-10:xMINimagePIXpos+XimagePIX+10);
dataMOD4imagePIX = ddata4(yMINimagePIXpos-YimagePIX-10:yMINimagePIXpos+10,xMINimagePIXpos-XimagePIX-10:xMINimagePIXpos+XimagePIX+10);
dataMOD43imagePIX = ddata43(yMINimagePIXpos-YimagePIX-10:yMINimagePIXpos+10,xMINimagePIXpos-XimagePIX-10:xMINimagePIXpos+XimagePIX+10);

%%% redefining x-y cooerdinated in the image having the vertex at (0,0) 
xPOSimagePIX = x_coordMODimagePIX - xVERTEXimagePIX;
yPOSimagePIX = y_coordMODimagePIX - yVERTEXimagePIX;
% xPOSimagePIX = x_coordMODimagePIX - xMINimagePIX;
% yPOSimagePIX = y_coordMODimagePIX - yMINimagePIX;

%% converting the area of interest coordinates from pixels to physical mm
%%% mapping pixels back into mm
xPIXposMM = xPOSimagePIX.*physTOimagePIX.*physPIXsize; % 
yPIXposMM = yPOSimagePIX.*physTOimagePIX.*physPIXsize; % 


%% Image recorded on CCD

if (imageCCD == 'y')
    figure(1)
    subplot(3,1,1); 
    imagesc(xPOSimagePIX,yPOSimagePIX,dataMOD3imagePIX);
    hold on 
%     plot(0,-yHOLEimagePIX,'b*')
    hold off
    shading interp
    %caxis([0 max(max(dataMOD3imagePIX))/1]);
    axis equal tight
    colorbar;
    colormap('Hot')
    subplot(3,1,2); 
    imagesc(xPOSimagePIX,yPOSimagePIX,dataMOD4imagePIX);
    hold on 
%     plot(0,-yHOLEimagePIX,'b*')
    hold off
    shading interp
    %caxis([0 max(max(dataMOD4imagePIX))/1]);
    axis equal tight
    colorbar;
    colormap('Hot')
    subplot(3,1,3); 
    imagesc(xPOSimagePIX,yPOSimagePIX,dataMOD43imagePIX);
    hold on 
%     plot(0,-yHOLEimagePIX,'b*')
    hold off
    shading interp
    %caxis([0 max(max(dataMOD43imagePIX))/1]);
    axis equal tight
    colorbar;
    colormap('Hot')
end

%% set all data values outside mirror area to 0

if (applyMASK == 'y')
    secPARimagePIX = zeros(y_sizeMODimagePIX,x_sizeMODimagePIX);
    for hh = 1:x_sizeMODimagePIX
        for ff = 1:y_sizeMODimagePIX
            if (sqrt(xPOSimagePIX(hh)^2 + yPOSimagePIX(ff)^2) <= rMIRRimagePIX) && (yPOSimagePIX(ff)<=(yMINimagePIX-yVERTEXimagePIX))
                secPARimagePIX(ff,hh) = 1;
            else
                secPARimagePIX(ff,hh) = 0;
            end
        end
    end
    dataMOD3imagePIX = dataMOD3imagePIX.*secPARimagePIX;
    dataMOD4imagePIX = dataMOD4imagePIX.*secPARimagePIX;
    dataMOD43imagePIX = dataMOD43imagePIX.*secPARimagePIX;
    
    if (plotMASK == 'y')
        figure(2)
        subplot(3,1,1); 
        imagesc(xPOSimagePIX,yPOSimagePIX,dataMOD3imagePIX);
        hold on 
%         plot(0,-yHOLEimagePIX,'b*')
        hold off
        shading interp
        caxis([0 max(max(dataMOD3imagePIX))/3]);
        axis equal tight
        colorbar;
        colormap('Hot')
        subplot(3,1,2); 
        imagesc(xPOSimagePIX,yPOSimagePIX,dataMOD4imagePIX);
        hold on 
%         plot(0,-yHOLEimagePIX,'b*')
        hold off
        shading interp
        caxis([0 max(max(dataMOD4imagePIX))/3]);
        axis equal tight
        colorbar;
        colormap('Hot')
        subplot(3,1,3);
        imagesc(xPOSimagePIX,yPOSimagePIX,dataMOD43imagePIX);
        hold on
%         plot(0,-yHOLEimagePIX,'b*')
        hold off
        shading interp
        caxis([0 max(max(dataMOD43imagePIX))/3]);
        axis equal tight
        colorbar;
        colormap('Hot')
    end
end


%% Azimuthal and polar angles calculation wrt parabolid focus
%%% 
%%% 
%%% First z-values corresponding to x-y coordinate pair are assigned
%%%
%%% Then azimuthal angle PHI is calculated using x-z values wrt (Fx,Fz)
%%%
%%% --> PHI=0 for x=0 and z>zHOLE and increasing clockwise
%%%
%%%
%%% Then polar angle THETA is calculated using (x,y,z) coord wrt (Fx,Fy,Fz)
%%% 

%%% Assignment of z-values (only to points within mirror image onto x-y)
zPIXposMM = zeros(y_sizeMODimagePIX,x_sizeMODimagePIX);
for hh = 1:x_sizeMODimagePIX
    for ff = 1:y_sizeMODimagePIX
        if (sqrt(xPOSimagePIX(hh)^2 + yPOSimagePIX(ff)^2) <= rMIRRimagePIX) && (yPOSimagePIX(ff)<=(yMINimagePIX-yVERTEXimagePIX))
            zPIXposMM(ff,hh) = k*(xPIXposMM(hh)^2 + yPIXposMM(ff)^2);
        else
            zPIXposMM(ff,hh) = 0;
        end
    end
end

%%% (x,y,z) for the mirror hole

%%% Calculation of azimuthal angle PHI
phiPIXposRAD = zeros(y_sizeMODimagePIX,x_sizeMODimagePIX);
for hh = 1:x_sizeMODimagePIX
    for ff = 1:y_sizeMODimagePIX
        if (sqrt(xPOSimagePIX(hh)^2 + yPOSimagePIX(ff)^2) > rMIRRimagePIX) || (yPOSimagePIX(ff)>(yMINimagePIX-yVERTEXimagePIX))
            phiPIXposRAD(ff,hh) = 0;
        else
            if (xPIXposMM(hh) == 0) && (zPIXposMM(ff,hh) >= zHOLE)
                phiPIXposRAD(ff,hh) = 0;
            elseif (xPIXposMM(hh) == 0) && (zPIXposMM(ff,hh) < zHOLE)
                phiPIXposRAD(ff,hh) = pi;
            elseif (xPIXposMM(hh) < 0) && (zPIXposMM(ff,hh) == zHOLE)
                phiPIXposRAD(ff,hh) = pi/2;
            elseif (xPIXposMM(hh) > 0) && (zPIXposMM(ff,hh) == zHOLE)
                phiPIXposRAD(ff,hh) = 3*pi/2;
            elseif (xPIXposMM(hh) < 0) && (zPIXposMM(ff,hh) > zHOLE)
                phiPIXposRAD(ff,hh) = atan(-xPIXposMM(hh)/(zPIXposMM(ff,hh)-zHOLE));
            elseif (xPIXposMM(hh) < 0) && (zPIXposMM(ff,hh) < zHOLE)
                phiPIXposRAD(ff,hh) = pi/2 - atan((zPIXposMM(ff,hh)-zHOLE)/(-xPIXposMM(hh)));
            elseif (xPIXposMM(hh) > 0) && (zPIXposMM(ff,hh) < zHOLE)
                phiPIXposRAD(ff,hh) = pi + atan(-xPIXposMM(hh)/(zPIXposMM(ff,hh)-zHOLE));
            else
                phiPIXposRAD(ff,hh) = 3*pi/2 - atan((zPIXposMM(ff,hh)-zHOLE)/(-xPIXposMM(hh)));
            end
        end
    end
end

phiPIXposDEG = 180*phiPIXposRAD/pi;


%%% Calculation of polar angle THETA
thetaPIXposRAD = zeros(y_sizeMODimagePIX,x_sizeMODimagePIX);
for hh = 1:x_sizeMODimagePIX
    for ff = 1:y_sizeMODimagePIX
        if (sqrt(xPOSimagePIX(hh)^2 + yPOSimagePIX(ff)^2) > rMIRRimagePIX) || (yPOSimagePIX(ff)>(yMINimagePIX-yVERTEXimagePIX))
            thetaPIXposRAD(ff,hh) = 0;
        else
            if yPIXposMM(ff) == -yHOLE
                thetaPIXposRAD(ff,hh) = 0;
            else
                xzDIST = sqrt(xPIXposMM(hh)^2+(zPIXposMM(ff,hh)-zHOLE)^2);
%                 thetaPIXposRAD(ff,hh) = atan(-yPIXposMM(ff)/xzDIST);
                thetaPIXposRAD(ff,hh) = atan(xzDIST/(-yPIXposMM(ff)));
            end
        end
    end
end

thetaPIXposDEG = 180*thetaPIXposRAD/pi;

%%% Calculation of solid angle OMEGA
OmegaPIXposRAD = zeros(y_sizeMODimagePIX,x_sizeMODimagePIX);
halfPIX = 0.5*physTOimagePIX.*physPIXsize;
% WB = waitbar(0,'Please wait...');
for hh = 1:x_sizeMODimagePIX
    for ff = 1:y_sizeMODimagePIX
        if (sqrt(xPOSimagePIX(hh)^2 + yPOSimagePIX(ff)^2) > rMIRRimagePIX) || (yPOSimagePIX(ff)>(yMINimagePIX-yVERTEXimagePIX))
            OmegaPIXposRAD(ff,hh) = 0;
        else
            xPIXposMM1 = xPIXposMM(hh)-halfPIX;
            xPIXposMM2 = xPIXposMM(hh)+halfPIX;
            yPIXposMM1 = -yPIXposMM(ff)-halfPIX;
            yPIXposMM2 = -yPIXposMM(ff)+halfPIX;
            OmegaPIXposRAD(ff,hh) = dblquad(@solidANGLEparaboloid,xPIXposMM1,xPIXposMM2,yPIXposMM1,yPIXposMM2,[],[],k,0,zHOLE);
        end
    end
%     waitbar(hh/x_sizeMODimagePIX)
end
% close(WB) ;

%%% plot PHI,THETA,OMEGA for the mirror
if (plotMIRRORangles == 'y')
figure(3)
subplot(3,1,1); 
imagesc(xPIXposMM,yPIXposMM,thetaPIXposDEG);
% imagesc(xPOSimagePIX,yPOSimagePIX,thetaPIXposMM);
% imagesc(x_coordMODimagePIX,y_coordMODimagePIX,thetaPIXposMM);
% hold on 
% plot(0,-yHOLEimagePIX,'b*')
% hold off
shading interp
% caxis([-2 0]);
axis equal tight
colorbar;
colormap('Hot')
subplot(3,1,2); 
imagesc(xPIXposMM,yPIXposMM,phiPIXposDEG);
% imagesc(xPOSimagePIX,yPOSimagePIX,phiPIXposMM);
% imagesc(x_coordMODimagePIX,y_coordMODimagePIX,phiPIXposMM);
% hold on 
% plot(0,-yHOLEimagePIX,'b*')
% hold off
shading interp
% caxis([0 270]);
axis equal tight
colorbar;
colormap('Hot')
subplot(3,1,3); 
imagesc(xPIXposMM,yPIXposMM,(OmegaPIXposRAD/max(max(OmegaPIXposRAD))));
% imagesc(xPIXposMM,yPIXposMM,(OmegaPIXposRAD));
% imagesc(xPOSimagePIX,yPOSimagePIX,thetaPIXposMM);
% imagesc(x_coordMODimagePIX,y_coordMODimagePIX,thetaPIXposMM);
% hold on 
% plot(0,-yHOLEimagePIX,'b*')
% hold off
shading interp
% caxis([-2 0]);
axis equal tight
colorbar;
colormap('Hot')
end


%% Aberration area removal
%%% values within this sector are set to 0

if (aberPHI == 'y')
    %     WB = waitbar(0,'Please wait...');
    for hh = 1:x_sizeMODimagePIX
        for ff = 1:y_sizeMODimagePIX
            if (sqrt(xPOSimagePIX(hh)^2 + yPOSimagePIX(ff)^2) > rMIRRimagePIX) || (yPOSimagePIX(ff)>(yMINimagePIX-yVERTEXimagePIX))
                dataMOD3imagePIX(ff,hh) = 0;
                dataMOD4imagePIX(ff,hh) = 0;
                dataMOD43imagePIX(ff,hh) = 0;
            else
                if (phiPIXposDEG(ff,hh) >= phiABERdeg1) && (phiPIXposDEG(ff,hh) <= phiABERdeg2)
                    dataMOD3imagePIX(ff,hh) = 0;
                    dataMOD4imagePIX(ff,hh) = 0;
                    dataMOD43imagePIX(ff,hh) = 0;
                end
            end
        end
        %         waitbar(hh/x_sizeMODimagePIX)
    end
    %     close(WB) ;
end


%% Solid angle normalization of the data
OmegaPIXposRADnorm = OmegaPIXposRAD/max(max(OmegaPIXposRAD));
if (solidANGLEnorm == 'y')
%     WB = waitbar(0,'Please wait...');
    for hh = 1:x_sizeMODimagePIX
        for ff = 1:y_sizeMODimagePIX
            if (sqrt(xPOSimagePIX(hh)^2 + yPOSimagePIX(ff)^2) > rMIRRimagePIX) || (yPOSimagePIX(ff)>(yMINimagePIX-yVERTEXimagePIX))
                dataMOD3imagePIX(ff,hh) = 0;
                dataMOD4imagePIX(ff,hh) = 0;
                dataMOD43imagePIX(ff,hh) = 0;
            else
                dataMOD3imagePIX(ff,hh) = dataMOD3imagePIX(ff,hh)./OmegaPIXposRADnorm(ff,hh);
                dataMOD4imagePIX(ff,hh) = dataMOD4imagePIX(ff,hh)./OmegaPIXposRADnorm(ff,hh);
                dataMOD43imagePIX(ff,hh) = dataMOD43imagePIX(ff,hh)./OmegaPIXposRADnorm(ff,hh);
            end
        end
%         waitbar(hh/x_sizeMODimagePIX)
    end
%     close(WB) ;
end

%% Intensity = f(THETA) 
% %%% Evaluation of intensity as function of polar angle THETA. 
% %%% Intensity is integrated over the azimuthal angle PHI.
% %%%
if (intVStheta == 'y')
thetaPIXposDEGround = round(100*thetaPIXposDEG);
thetaPIXposDEGmin = min(min(thetaPIXposDEGround));
thetaPIXposDEGmax = max(max(thetaPIXposDEGround));
thetaPIXposDEGcomp = (thetaPIXposDEGmin:thetaPIXposDEGmax)';

%%% intensities and occurences at each specific values of THETA
thetaPIXposDEGintANDtimes3 = zeros(length(thetaPIXposDEGcomp),2);
thetaPIXposDEGintANDtimes4 = zeros(length(thetaPIXposDEGcomp),2);
thetaPIXposDEGintANDtimes43 = zeros(length(thetaPIXposDEGcomp),2);
well = 0;
for dd = 1 : length(thetaPIXposDEGcomp)
    for hh = 1:x_sizeMODimagePIX
        for ff = 1:y_sizeMODimagePIX
            if (sqrt(xPOSimagePIX(hh)^2 + yPOSimagePIX(ff)^2) > rMIRRimagePIX) || (yPOSimagePIX(ff)>(yMINimagePIX-yVERTEXimagePIX))
                nik = 0;
            else
                if (thetaPIXposDEGround(ff,hh) == dd)
                  thetaPIXposDEGintANDtimes3(dd,1) =  thetaPIXposDEGintANDtimes3(dd,1) + dataMOD3imagePIX(ff,hh);
                  thetaPIXposDEGintANDtimes3(dd,2) = thetaPIXposDEGintANDtimes3(dd,2) + 1;
                  thetaPIXposDEGintANDtimes4(dd,1) =  thetaPIXposDEGintANDtimes4(dd,1) + dataMOD4imagePIX(ff,hh);
                  thetaPIXposDEGintANDtimes4(dd,2) = thetaPIXposDEGintANDtimes4(dd,2) + 1;
                  thetaPIXposDEGintANDtimes43(dd,1) =  thetaPIXposDEGintANDtimes43(dd,1) + dataMOD43imagePIX(ff,hh);
                  thetaPIXposDEGintANDtimes43(dd,2) = thetaPIXposDEGintANDtimes43(dd,2) + 1;
                else
                    well = 1;
                end
            end
        end
    end
end

%%% the zero intensity values are removed (pixels not counting)
thetaPIXposDEGcompNOzeros3 = [];
thetaPIXposDEGintANDtimesNOzeros3 = [];
qq = 1;
for dd = 1 : length(thetaPIXposDEGcomp)
    if thetaPIXposDEGintANDtimes3(dd,1) == 0
        well = 1;
    else
        thetaPIXposDEGcompNOzeros3(qq) = thetaPIXposDEGcomp(dd);
        thetaPIXposDEGintANDtimesNOzeros3(qq,1) = thetaPIXposDEGintANDtimes3(dd,1);
        thetaPIXposDEGintANDtimesNOzeros3(qq,2) = thetaPIXposDEGintANDtimes3(dd,2);
        qq = qq + 1;
    end
  
end

thetaPIXposDEGcompNOzeros4 = [];
thetaPIXposDEGintANDtimesNOzeros4 = [];
qq = 1;
for dd = 1 : length(thetaPIXposDEGcomp)
    if thetaPIXposDEGintANDtimes4(dd,1) == 0
        well = 1;
    else
        thetaPIXposDEGcompNOzeros4(qq) = thetaPIXposDEGcomp(dd);
        thetaPIXposDEGintANDtimesNOzeros4(qq,1) = thetaPIXposDEGintANDtimes4(dd,1);
        thetaPIXposDEGintANDtimesNOzeros4(qq,2) = thetaPIXposDEGintANDtimes4(dd,2);
        qq = qq + 1;
    end
  
end

thetaPIXposDEGcompNOzeros43 = [];
thetaPIXposDEGintANDtimesNOzeros43 = [];
qq = 1;
for dd = 1 : length(thetaPIXposDEGcomp)
    if thetaPIXposDEGintANDtimes43(dd,1) == 0
        well = 1;
    else
        thetaPIXposDEGcompNOzeros43(qq) = thetaPIXposDEGcomp(dd);
        thetaPIXposDEGintANDtimesNOzeros43(qq,1) = thetaPIXposDEGintANDtimes43(dd,1);
        thetaPIXposDEGintANDtimesNOzeros43(qq,2) = thetaPIXposDEGintANDtimes43(dd,2);
        qq = qq + 1;
    end
  
end


%%% average of the intesities for each THETA
LL = max(size(thetaPIXposDEGintANDtimesNOzeros3));
thetaPIXposDEGintNOzerosAV3 = zeros(LL,1);
for pp = 1 : LL
    thetaPIXposDEGintNOzerosAV3(pp) = thetaPIXposDEGintANDtimesNOzeros3(pp,1)/thetaPIXposDEGintANDtimesNOzeros3(pp,2);
end
LL = length(thetaPIXposDEGintNOzerosAV3);
thetaPIXposDEGintNOzerosAVsmooth3 = zeros(LL,1);
for pp = 1 : LL
    if (pp <= 20)
        thetaPIXposDEGintNOzerosAVsmooth3(pp) = mean(thetaPIXposDEGintNOzerosAV3(1:20+pp));
    elseif (pp >= LL-20)
        thetaPIXposDEGintNOzerosAVsmooth3(pp) = mean(thetaPIXposDEGintNOzerosAV3(pp-20:LL));
    else
         thetaPIXposDEGintNOzerosAVsmooth3(pp) = mean(thetaPIXposDEGintNOzerosAV3(pp-20:pp+20));
    end
end
%%%
LL = max(size(thetaPIXposDEGintANDtimesNOzeros4));
thetaPIXposDEGintNOzerosAV4 = zeros(LL,1);
for pp = 1 : LL
    thetaPIXposDEGintNOzerosAV4(pp) = thetaPIXposDEGintANDtimesNOzeros4(pp,1)/thetaPIXposDEGintANDtimesNOzeros4(pp,2);
end
LL = length(thetaPIXposDEGintNOzerosAV4);
thetaPIXposDEGintNOzerosAVsmooth4 = zeros(LL,1);
for pp = 1 : LL
    if (pp <= 20)
        thetaPIXposDEGintNOzerosAVsmooth4(pp) = mean(thetaPIXposDEGintNOzerosAV4(1:20+pp));
    elseif (pp >= LL-20)
        thetaPIXposDEGintNOzerosAVsmooth4(pp) = mean(thetaPIXposDEGintNOzerosAV4(pp-20:LL));
    else
         thetaPIXposDEGintNOzerosAVsmooth4(pp) = mean(thetaPIXposDEGintNOzerosAV4(pp-20:pp+20));
    end
end
%%%
LL = max(size(thetaPIXposDEGintANDtimesNOzeros43));
thetaPIXposDEGintNOzerosAV43 = zeros(LL,1);
for pp = 1 : LL
    thetaPIXposDEGintNOzerosAV43(pp) = thetaPIXposDEGintANDtimesNOzeros43(pp,1)/thetaPIXposDEGintANDtimesNOzeros43(pp,2);
end
LL = length(thetaPIXposDEGintNOzerosAV43);
thetaPIXposDEGintNOzerosAVsmooth43 = zeros(LL,1);
for pp = 1 : LL
    if (pp <= 20)
        thetaPIXposDEGintNOzerosAVsmooth43(pp) = mean(thetaPIXposDEGintNOzerosAV43(1:20+pp));
    elseif (pp >= LL-20)
        thetaPIXposDEGintNOzerosAVsmooth43(pp) = mean(thetaPIXposDEGintNOzerosAV43(pp-20:LL));
    else
         thetaPIXposDEGintNOzerosAVsmooth43(pp) = mean(thetaPIXposDEGintNOzerosAV43(pp-20:pp+20));
    end
end


figure(4)
subplot(2,1,1); 
% plot(thetaPIXposDEGcompNOzeros3/100,thetaPIXposDEGintNOzerosAV3,'b*')
hold on
plot(thetaPIXposDEGcompNOzeros3/100,thetaPIXposDEGintNOzerosAVsmooth3,'b*','Linewidth',1)
% plot(thetaPIXposDEGcompNOzeros4/100,thetaPIXposDEGintNOzerosAV4,'r*')
plot(thetaPIXposDEGcompNOzeros4/100,thetaPIXposDEGintNOzerosAVsmooth4,'g*','Linewidth',1)
hold off
% ylim([575 620])
subplot(2,1,2); 
% plot(thetaPIXposDEGcompNOzeros43/100,thetaPIXposDEGintNOzerosAV43,'k*')
hold on
plot(thetaPIXposDEGcompNOzeros43/100,thetaPIXposDEGintNOzerosAVsmooth43,'k*','Linewidth',1)
hold off
% ylim([3 30])
end

%% Polar plot
% %%%
% %%%
% %%%

xTHETA = [];
yTHETA = [];
dataPOLAR = [];
dd = 1;
for hh = 1:x_sizeMODimagePIX
    for ff = 1:y_sizeMODimagePIX
        if (sqrt(xPOSimagePIX(hh)^2 + yPOSimagePIX(ff)^2) > rMIRRimagePIX) || (yPOSimagePIX(ff)>(yMINimagePIX-yVERTEXimagePIX))
            nik = 0;
        else
            xTHETA(dd) = 180*thetaPIXposRAD(ff,hh)*cos(phiPIXposRAD(ff,hh))/pi;
            yTHETA(dd) = 180*thetaPIXposRAD(ff,hh)*sin(phiPIXposRAD(ff,hh))/pi;
            dataPOLAR(dd) = dataMOD43imagePIX(ff,hh);
            dd=dd+1;
        end
    end
end


xTHETA = (round((100*xTHETA)))';
yTHETA = (round((100*yTHETA)))';
dataPOLAR = dataPOLAR';
for kkl = 1 : length(dataPOLAR)
    if dataPOLAR(kkl) < 0
        dataPOLAR(kkl) = 0;
    end
end



xTHETAreg = (-9000:10:9000)';
yTHETAreg = (-9000:10:9000)';
xyTHETAreg = zeros(length(yTHETAreg),length(xTHETAreg));

% WB = waitbar(0,'Please wait...');
% 
% for tt = 1:length(xTHETA)
%     xTHETAval = xTHETA(tt);
%     yTHETAval = yTHETA(tt);
%     aa = xTHETAval - xTHETAreg(1) +1;
%     bb = yTHETAval - yTHETAreg(1) +1;
%     xyTHETAreg(bb,aa) = dataPOLAR(tt);
%     waitbar(tt/length(xTHETA))
% end
% close(WB) ;

[xTHETAi yTHETAi] = meshgrid(xTHETAreg,yTHETAreg);
dataPOLARi = griddata(xTHETA,yTHETA,dataPOLAR,xTHETAi,yTHETAi);
floorDATA = dataPOLARi<1000;
dataPOLARifloor = (dataPOLARi - dataPOLARi.*floorDATA) + floorDATA*1000;

if (PLOTpolar == 'y')
whitebg('black'); % tells polar to do in white lines on black
figure(5);clf;
set(gcf,'Position',[200 200 800 400]);
ax1=axes('Color','Black');
set(gca,'XLim',[-90 90],'YLim',[-90 90]);
h = polar([0 2*pi;0 2*pi], [30 30;90 90],'w:'); % any polar plot for axes
set(findall(gca,'type','patch'),'FaceColor',[.5 .5 .5],...
    'EdgeColor',[.5 .5 .5]); % change to grey
% set(findall(gca,'type','patch'),'ZData',0); % move to bottom
delete(h); % get rid of plot
axis equal tight; % make a square

hold on;

g = surf(xTHETAi/100,yTHETAi/100,dataPOLARifloor); % plot surface
shading interp
axis equal tight
view(-90, 90)
% 
% ax2=copyobj(ax1,gcf); % copy polar to put on top of surface
% set(gcf, 'currentaxes', ax2)
% delete(findall(gca,'type','surface')); % delete plot
% delete(findall(gca,'type','patch')); % delete polar bg
% delete(findall(ax1,'type','text')); 
% delete(findall(ax1,'type','line'));
% set(gca,'XLim',[-100 100],'YLim',[-100 100]);
% axis equal tight
% ax3=axes('visible','off','XLim',[-100 100],'YLim',[-100 100]);
% set(gcf, 'currentaxes', ax3);
% axis equal tight
% marker=rectangle('curvature',[1 1],'Position',[-30 -30 60 60],'edgecolor','white');
% set(gcf, 'currentaxes', ax1);
% colorbar('YColor','white');
 colormap('Hot')
% view(-90, 90)
% 
% set(ax1,'Position','default');
% set(ax2,'Position','default','color','none');
% set(ax3,'Position','default','color','none');

set(gcf, 'color', 'none','inverthardcopy', 'off');

end
%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%              EXTRA BITS              %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%              EXTRA BITS              %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%              EXTRA BITS              %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% figure(1)
% % subplot(2,1,1); 
% imagesc(yTHETAreg,xTHETAreg,xyTHETAreg);
% % imagesc(xPOSimagePIX,yPOSimagePIX,thetaPIXposMM);
% % imagesc(x_coordMODimagePIX,y_coordMODimagePIX,thetaPIXposMM);
% % hold on 
% % plot(0,-yHOLEimagePIX,'b*')
% % hold off
% shading interp
% % caxis([-2 0]);
% axis equal tight
% colorbar;
% colormap('Hot')
% colormap('Hot')


%% parabolic emicircle check
%%% this part allows to check the region defined as the parabolic emicircle
%%% by the parameters chosen before. 
%%% !!! COMMENT IF NOT NEEDED!!!

% secPARimagePIX = zeros(y_sizeMODimagePIX,x_sizeMODimagePIX);
% for hh = 1:x_sizeMODimagePIX
%     for ff = 1:y_sizeMODimagePIX
%         if (sqrt(xPOSimagePIX(hh)^2 + yPOSimagePIX(ff)^2) <= rMIRRimagePIX) && (yPOSimagePIX(ff)<=(yMINimagePIX-yVERTEXimagePIX))
%             secPARimagePIX(ff,hh) = 1;
%         else
%             secPARimagePIX(ff,hh) = 0;
%         end
%     end
% end

% secPARimagePIX = zeros(y_sizeMODimagePIX,x_sizeMODimagePIX);
% for hh = 1:x_sizeMODimagePIX
%     for ff = 1:y_sizeMODimagePIX
%         if (sqrt(xPOSimagePIX(hh)^2 + yPOSimagePIX(ff)^2) > rMIRRimagePIX) || (yPOSimagePIX(ff)>(yMINimagePIX-yVERTEXimagePIX))
%             secPARimagePIX(ff,hh) = 1;
%         else
%             secPARimagePIX(ff,hh) = 0;
%         end
%     end
% end
% 
% figure(1)
% subplot(2,1,1); 
% % imagesc(xPIXposMM,yPIXposMM,dataMOD3imagePIX);
% imagesc(xPOSimagePIX,yPOSimagePIX,dataMOD3imagePIX);
% % imagesc(x_coordMODimagePIX,y_coordMODimagePIX,dataMOD4imagePIX);
% % hold on 
% % plot(0,-yHOLEimagePIX,'b*')
% % hold off
% shading interp
% % % caxis([0 50]);
% axis equal tight
% colorbar;
% colormap('Hot')
% subplot(2,1,2); 
% % imagesc(xPIXposMM,yPIXposMM,secPARimagePIX);
% imagesc(xPOSimagePIX,yPOSimagePIX,secPARimagePIX);
% % imagesc(x_coordMODimagePIX,y_coordMODimagePIX,secPARimagePIX);
% % hold on 
% % plot(0,-yHOLEimagePIX,'b*')
% % hold off
% shading interp
% axis equal tight
% colorbar;
% colormap('Hot')


