clear all;close all;clc;

addpath('./exportScript/')
addpath('./data set/')
% addpath('./multi/')

% setting this to 'y' will cause HSI_CCDimagePOLAR to generate
% plots. This may take a long time if the entire script is run with doPlots
% = 'y'. It is recommended to run only individual sections with 'y'
doPlots = 'y';

%set the background gold reading file

%data3 = importfile('20s 11_4na  180 background.txt');

        
% dataName = [num2str(R),'-',num2str(C),'-3pA30s.txt'];
% data4 = importfile(dataName);
dataNames = {
    '20s 9na 000.txt';
    '20s 9na 004.txt';
    '20s 9na 008.txt';
    '20s 9na 012.txt';
    '20s 9na 016.txt';
    '20s 9na 020.txt';
    '20s 9na 024.txt';
    '20s 9na 028.txt';
    '20s 9na 032.txt';
    '20s 9na 036.txt';
    '20s 9na 040.txt';
    '20s 9na 044.txt';
    '20s 9na 048.txt';
    '20s 9na 050.txt';
    '20s 9na 052.txt';
    '20s 9na 056.txt';
    '20s 9na 060.txt';
    '20s 9na 064.txt';
    '20s 9na 068.txt';
    '20s 9na 072.txt';
    '20s 9na 076.txt';
    '20s 9na 080.txt';
    '20s 9na 084.txt';
    '20s 9na 088.txt';
    '20s 9na 092.txt';
    '20s 9na 096.txt';
    '20s 9na 100.txt'
    };

for runID=1:length(dataNames)
    data4 = importfile(dataNames{runID});
    HSI_CCDimagePOLAR;
    if (doPlots == 'y')
        figure(13);
        subplot(1,length(dataNames),runID);
        colormap('hot');
        g = surf(xTHETAi/100,yTHETAi/100,dataPOLARifloor); % plot surface
        shading interp
        axis equal tight
        view(-90, 90); %colorbar;

        
    end

        %leftHalfCCD{runID} = ddata43(yMINimagePIXpos-100:yMINimagePIXpos,xMINimagePIXpos-100:xMINimagePIXpos);
        leftHalfCCD{runID} = ddata43(130:143,307:324);
        
        leftMax(runID) = max(max(leftHalfCCD{runID}));
        leftMhalf(runID) = leftMax(runID)/2;
        leftSpotdb3 = (leftHalfCCD{runID}>leftMhalf(runID)).*leftHalfCCD{runID};
        leftSpotInt(runID) = sum(sum(leftSpotdb3));
        leftSideInt(runID) = sum(sum(leftHalfCCD{runID}));
        leftSpotNum(runID) = nnz(leftSpotdb3);
        leftSpotAvg(runID) = sum(sum(leftSpotdb3))/nnz(leftSpotdb3);
        
        %rightHalfCCD{runID} = ddata43(yMINimagePIXpos-100:yMINimagePIXpos,xMINimagePIXpos:xMINimagePIXpos+100);
        rightHalfCCD{runID} = ddata43(133:146,325:342);
        rightMax(runID) = max(max(rightHalfCCD{runID}));
        rightMhalf(runID) = rightMax(runID)/2;
        rightSpotdb3 = (rightHalfCCD{runID}>rightMhalf(runID)).*rightHalfCCD{runID};
        rightSpotAvg(runID) = sum(sum(rightSpotdb3))/nnz(rightSpotdb3);
        rightSpotInt(runID) = sum(sum(rightSpotdb3));
        rightSideInt(runID) = sum(sum(rightHalfCCD{runID}));
        rightSpotNum(runID) = nnz(rightSpotdb3);
        rightSpotAvg(runID) = sum(sum(rightSpotdb3))/nnz(rightSpotdb3);
        
        leftMax(runID) = leftSpotAvg(runID)
        rightMax(runID) = rightSpotAvg(runID)
        
        figure(5);
        export_fig(strcat('img-',dataNames{runID},'.png'),'-png');
        close;
        
end
%%

figure();
leftMaxNorm=leftMax./leftMax(1);
rightMaxNorm=rightMax./rightMax(1);
normRelativeBright = leftMaxNorm./rightMaxNorm;
plot(leftMax);hold on;plot(rightMax);

legend('left spot max','right spot max');

figure();plot(normRelativeBright);

%%
figure(4);clf;%whitebg;
%ySpline = spline([1 2 3 4 5],leftMaxNorm,splinePoints);
%plot(splinePoints,ySpline);

set(gca,'FontSize',12)
xx=linspace(1,16,1000);

%splinePoints = linspace(1,5,1000);

%ySpline = spline([1 2 3 4 5],leftMaxNorm,splinePoints);
%plot(splinePoints,ySpline);

set(gca,'FontSize',40)
set(gca,'xtick',[1:16]);
set(gca,'ytick',[.2 .4 .6 .8 1]);
set(gca,'xticklabel',[(0:2:30)],'LineWidth',2.5);
set(gcf, 'Color', 'None');set(gca, 'Color', 'None');
xlabel('Injection point separation, \mum');
ylabel('Relative spot intensity')
axis([1 17 0 1]);
hold on
scatter([1:16],normRelativeBright,150,'w','SizeData',600,'LineWidth',2.5);
%set(gcf,'MarkerColor','black');
fitData = fit([1:16]',normRelativeBright','power2');
yy = fitData(xx);
plot(xx,yy,'w--','LineWidth',2.5);
box on;
set(gcf,'position',[100 900 1240 800]);
export_fig -transparent;
%legend('data','smoothing spline');


%%
figure(5);clf;hold on;
set(gcf, 'Color', 'white');
dwell_time=[0,4,8,12,16,20,24,28,32,36,40,44,48,50,52,56,60,64,68,72,76,80,...
    84,88,92,96,100];
% 
% leftMaxNorm=leftSideInt./(rightSideInt+leftSideInt);
% rightMaxNorm=rightSideInt./(rightSideInt+leftSideInt);
%

leftMaxNorm=leftSideInt./max(leftSideInt);
rightMaxNorm=rightSideInt./max(leftSideInt);

L=scatter(dwell_time',leftMaxNorm,'dk');
R=scatter(dwell_time',rightMaxNorm,'ok');
set(L,'SizeData',80);
set(R,'SizeData',80);
set(gca, 'Color', 'white','xcolor','black','ycolor','black');

Lfit=fit(dwell_time',leftMaxNorm','poly1');
Rfit=fit(dwell_time',rightMaxNorm','poly1');


plot(Lfit,dwell_time',leftMaxNorm,'--k');
plot(Rfit,dwell_time',rightMaxNorm,'--k');

maxAvg = max(max(leftSpotAvg, rightSpotAvg));

for runID=1:27
    leftBackground{runID} = (leftHalfCCD{runID}<(maxAvg*.1)).*leftHalfCCD{runID};
    leftError(runID) = sum(sum(leftBackground{runID}))/nnz(leftBackground{runID});

    rightBackground{runID} = (rightHalfCCD{runID}<(maxAvg*.1)).*rightHalfCCD{runID};
    rightError(runID) = sum(sum(rightBackground{runID}))/nnz(rightBackground{runID});
end

totalInt=leftSideInt+rightSideInt;
totalIntNorm=totalInt./max(totalInt)
totalIntNormInv=1./totalIntNorm

leftErrorWeight=(leftError./2).*totalIntNormInv.^4;

rightErrorWeight=(rightError./2).*totalIntNormInv.^4;

figure();hold on;plot(rightError);plot(leftError);
figure(5);hold on;
errorbar(dwell_time',leftSideInt./max(leftMaxNorm),leftErrorWeight./maxAvg);
errorbar(dwell_time',rightSideInt./max(leftMaxNorm),rightErrorWeight./maxAvg);
